@import "/src/assets/styles/grid-system.scss";
@import "/src/assets/styles/elevation-system.scss";
@import "/src/assets/styles/spacing-system.scss";

.card {
    display: flex;
    flex-direction: column;
    align-self: start;
    justify-self: center;
    // margin: 2.4rem;
    padding: 2.4rem;
    color: $on-primary-color;
    border-radius: 0.8rem;
}

.form-input-control {
    display: flex;
    flex-direction: column;
    margin-top: 0.4rem;
    padding-top: 0.8rem;
}

.form-input-control::after {
    max-height: 0;
    border-top: 1px solid $primary-light-color;
    border-bottom: 1px solid #ffffff00;
    margin-bottom: 0.8rem;
    content: "";
}

.form-input-control::before {
    position: relative;
    max-height: 0;
    top: 33px;
    border-bottom: 2px solid $secondary-color;
    content: "";
    -webkit-transform: scaleX(0);
    -moz-transform: scaleX(0);
    -o-transform: scaleX(0);
    -ms-transform: scaleX(0);
    transform: scaleX(0);
}

.form-input-control__text-input-label {
    display: flex;
    height: 0;
    position: relative;
    top: -2.4rem;
    font-size: 1.6rem;
    color: $primary-light-color;
    -webkit-transform-origin: top left;
    -moz-transform-origin: top left;
    -o-transform-origin: top left;
    -ms-transform-origin: top left;
    transform-origin: top left;
    transition: 0.3s cubic-bezier(0.4, 0, 0.6, 1);
}
.form-input-control__text-input {
    display: flex;
    width: 100%;
    padding: 0.8rem 0;
    max-height: 3.2rem;
    border-top: none;
    border-left: none;
    border-bottom: none;
    border-right: none;
    outline: none;
    font-size: 1.6rem;
}
.form-input-control__text-input::placeholder {
    opacity: 0;
}

.form-input-control__text-input:focus-within
    ~ .form-input-control__text-input-label,
.form-input-control__text-input:not(:placeholder-shown)
    ~ .form-input-control__text-input-label {
    // font-size: 1.2rem;
    color: $primary-color;
    -webkit-transform: translateY(-2rem) scale(0.75);
    -moz-transform: translateY(-2rem) scale(0.75);
    -o-transform: translateY(-2rem) scale(0.75);
    -ms-transform: translateY(-2rem) scale(0.75);
    transform: translateY(-2rem) scale(0.75);
}

.form-input-control:has(.form-input-control__text-input:focus-within)::before {
    -webkit-transform: scaleX(1);
    -moz-transform: scaleX(1);
    -o-transform: scaleX(1);
    -ms-transform: scaleX(1);
    transform: scaleX(1);
    -webkit-transition: 0.3s cubic-bezier(0.4, 0, 0.6, 1);
    -moz-transition: 0.3s cubic-bezier(0.4, 0, 0.6, 1);
    -o-transition: 0.3s cubic-bezier(0.4, 0, 0.6, 1);
    -ms-transition: 0.3s cubic-bezier(0.4, 0, 0.6, 1);
    transition: 0.3s cubic-bezier(0.4, 0, 0.6, 1);
}

.form-icon-button {
    display: flex;
    align-self: center;
    align-items: center;
    justify-content: center;
    width: 2.4rem;
    height: 2.4rem;
    border: none;
    color: $primary-color;
    background-color: $on-primary-color;
    cursor: pointer;
    span {
        display: flex;
    }
}

.form-icon-button:hover {
    border-radius: 50%;
    background-color: rgba($primary-light-color, 0.25);
    -webkit-transition: background-color 0.2s cubic-bezier(0.4, 0, 0.6, 1),
        border-radius 0.2s cubic-bezier(0.4, 0, 0.6, 1);
    -moz-transition: background-color 0.2s cubic-bezier(0.4, 0, 0.6, 1),
        border-radius 0.2s cubic-bezier(0.4, 0, 0.6, 1);
    -o-transition: background-color 0.2s cubic-bezier(0.4, 0, 0.6, 1),
        border-radius 0.2s cubic-bezier(0.4, 0, 0.6, 1);
    -ms-transition: background-color 0.2s cubic-bezier(0.4, 0, 0.6, 1),
        border-radius 0.2s cubic-bezier(0.4, 0, 0.6, 1);
    transition: background-color 0.2s cubic-bezier(0.4, 0, 0.6, 1),
        border-radius 0.2s cubic-bezier(0.4, 0, 0.6, 1);
}

.spacer {
    display: flex;
    flex-grow: 1;
}

.form-button {
    display: inline-flex;
    align-self: center;
    align-items: center;
    justify-content: center;
    position: relative;
    padding: 0.8rem;
    outline: 0;
    border: none;
    border-radius: 0.4rem;
    color: $on-secondary-color;
    background-color: $secondary-color;
    font-weight: 700;
    cursor: pointer;
    span {
        display: flex;
    }
}

.form-button::before {
    position: absolute;
    top: 0;
    left: 0;
    bottom: 0;
    right: 0;
    border-radius: 0.4rem;
    background-color: rgba($primary-light-color, 0);
    content: "";
}

.form-button:hover::before {
    background-color: rgba($on-primary-color, 0.2);
    -webkit-transition: background-color 0.2s cubic-bezier(0.4, 0, 0.6, 1);
    -moz-transition: background-color 0.2s cubic-bezier(0.4, 0, 0.6, 1);
    -o-transition: background-color 0.2s cubic-bezier(0.4, 0, 0.6, 1);
    -ms-transition: background-color 0.2s cubic-bezier(0.4, 0, 0.6, 1);
    transition: background-color 0.2s cubic-bezier(0.4, 0, 0.6, 1);
}

.form-button:active::before {
    background-color: rgba($on-primary-color, 0.5);
    -webkit-transition: background-color 0.1s cubic-bezier(0.4, 0, 0.6, 1);
    -moz-transition: background-color 0.1s cubic-bezier(0.4, 0, 0.6, 1);
    -o-transition: background-color 0.1s cubic-bezier(0.4, 0, 0.6, 1);
    -ms-transition: background-color 0.1s cubic-bezier(0.4, 0, 0.6, 1);
    animation: button-click;
    animation-duration: 0.1s;
    transition: background-color 0.1s cubic-bezier(0.4, 0, 0.6, 1);
}

.form-checkbox-control {
    display: flex;
    align-items: center;
    margin-top: 0.8rem;
    margin-bottom: 0.8rem;
    // padding-top: 0.8rem;
}
.form-checkbox-control__checkbox {
    display: flex;
    color: $primary-color;
    font-size: 1.6rem;
    cursor: pointer;
    -webkit-user-select: none;
    -moz-user-select: none;
    -o-user-select: none;
    -ms-user-select: none;
    user-select: none;

    input {
        position: absolute;
        opacity: 0;
        cursor: pointer;
        height: 0;
        width: 0;
    }

    .checkbox__label {
        display: flex;
        align-items: center;
        padding-left: 0.4rem;
    }

    .checkbox__checkmark {
        display: flex;
        align-content: center;
        justify-content: center;
        padding: 0.4rem;
        // height: 28px;
        // width: 28px;
    }

    .checkbox__checkmark:after {
        display: flex;
        align-self: center;
        justify-self: center;
        content: "check_box_outline_blank";
    }

    input:checked ~ .checkbox__checkmark:after {
        display: flex;
        align-self: center;
        justify-self: center;
        content: "check_box";
    }

    input:checked ~ .checkbox__checkmark {
        color: $secondary-color;
        font-weight: 700;
    }

    input:checked ~ .checkbox__label {
        text-decoration: underline;
    }
}

.form-checkbox-control__checkbox:hover input ~ .checkbox__checkmark,
.form-checkbox-control__checkbox input:focus-visible ~ .checkbox__checkmark {
    border-radius: 50%;
    background-color: rgba($primary-light-color, 0.25);
    transition: background-color 0.2s cubic-bezier(0.4, 0, 0.6, 1),
        border-radius 0.2s cubic-bezier(0.4, 0, 0.6, 1);
}

.form-checkbox-control__checkbox:hover input ~ .checkbox__label,
.form-checkbox-control__checkbox input:focus-visible ~ .checkbox__label {
    text-decoration: underline;
}

@keyframes button-click {
    from {
        transform: scale(0);
    }
    to {
        transform: scale(1);
    }
}
